<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Sebastian Baumann <sb@sitesystems.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Image Downloader' for the 'sb_downloader' extension.
 * with hook from Markus Dreyer <Markus@MadaXel.de>
 * with addons from Kurt Kunig kurt@kupix.de (Grafic of download/date & time)
 * extended and rewritten by Robert Heel <typo3.org@bobosch.de>
 * @author	Sebastian Baumann <sb@sitesystems.de>
 * @package	TYPO3
 * @subpackage	tx_sbdownloader
 */
class tx_sbdownloader_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_sbdownloader_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_sbdownloader_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'sb_downloader';	// The extension key.
	// var $pi_checkCHash = true;
	var $filebasepath	 = "uploads/tx_sbdownloader/";
	// multilanguage
	var $langArr;
	var $sys_language_mode;

	var $cat_rows = array();
	var $config = array();
	var $mHooks = array();

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		global $TSFE,$LANG;
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
			
	   // Preconfigure the typolink
		$this->local_cObj = t3lib_div::makeInstance("tslib_cObj");
		$this->local_cObj->setCurrentVal($GLOBALS["TSFE"]->id);
		$this->typolink_conf = $this->conf["typolink."];
		$this->typolink_conf["parameter."]["current"] = 1;
		$this->typolink_conf["additionalParams"] =
		$this->cObj->stdWrap($this->typolink_conf["additionalParams"],
		$this->typolink_conf["additionalParams."]);
		unset($this->typolink_conf["additionalParams."]);	


		$this->initHooks();
		
		$this->lang = $GLOBALS['TSFE']->config['config']['sys_language_uid'] ;
				
		// take objects from dedicated page or sysfolder
		$this->download = t3lib_div::_GP('download');
		$this->did = intval(t3lib_div::_GP('did'));
		$this->pid = intval($this->piVars['uid']);
		$this->keyword = trim($this->piVars['sword']);
		// if download
		if(isset($this->download)) {
			$this->downloadImage(basename($this->download),$this->did);
			exit;
		}

		// flexform Integration
		$this->pi_initPIflexform(); // Init and get the flexform data of the plugin

		// Template settings
		$templateflex_file = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_file', 's_template');
		$this->templateCode = $this->cObj->fileResource($templateflex_file?'uploads/tx_sbdownloader/' .	 $templateflex_file:$this->conf['templateFile']);
		
		// Flexform data
		$cat = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dynField', 'sDEF');
		$secureDownloads = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'secureDownloads', 's_conf');
		$filesize = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'filesize', 's_conf');
		$downloadcount = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'downloads', 's_conf');
		// Display Creationdate and -time !?    (KK)
		$showCRDate = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showCRDate', 's_conf');
		$showCRDate = trim($showCRDate) == '' ? $this->conf["displayCreationDate"] : $showCRDate;
		$showFiledate = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'filedate', 's_conf');
		$showFiledate = trim($showFiledate) == '' ? $this->conf["showFiledate"] : $showFiledate;
		$showEditDate = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showEditDate', 's_conf');
		$orderby = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'orderby', 's_conf');		
		$ascdesc = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ascdesc', 's_conf');
		$onlyFirst = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'onlyFirst', 's_conf');
		$showMore = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showMore', 's_conf');
		$singlePIDs = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'singlePID', 's_singlepid');
		// check orderby
		if($orderby == 'singleID'){
			$orderby = " FIELD(tx_sbdownloader_images.uid,$singlePIDs)";				
		}		
		if(empty($orderby)){
			$orderby = 'name';
		}
		// Copy Flexform data to $this->config
		$items=array('ascdesc','cat','downloadcount','filesize','onlyFirst','orderby','secureDownloads','showCRDate','showEditDate','showFiledate','showMore','singlePIDs');
		foreach($items as $item){
			$this->config[$item]=$$item;
		}

		// added by Simon Schick
		// If no display is set in the Typo-Element it will look at the TypoScript
		if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'what_to_display', 'sDEF')) {
		  $view = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'what_to_display', 'sDEF');
		} else {
			$view = $this->conf["what_to_display"];
		}
		
		$where=array();
		// Search
		if(!empty($this->keyword)){
			$keyword='"%'.$GLOBALS['TYPO3_DB']->quoteStr($this->keyword,'tx_sbdownloader_images').'%"';
			$where[]='tx_sbdownloader_images.description LIKE '.$keyword;
			$where[]='tx_sbdownloader_images.name LIKE '.$keyword;
			$where[]='tx_sbdownloader_images.longdescription LIKE '.$keyword;
			$where[]='tx_sbdownloader_images.linkdescription LIKE '.$keyword;
			$where=array('('.implode(' OR ',$where).')');
			// cache deaktivieren
			$this->pi_USER_INT_obj = 1;	
		}else{
			// cache aktiviert
			$this->pi_USER_INT_obj = 0;	
		}

		// separate views
		$view = explode(',',$view);
		
		foreach($view as $mode){
			switch($mode){
				case 'LIST':
					$this->template['template'] = $this->cObj->getSubpart($this->templateCode,'###TEMPLATE###');
					$this->template['listItem'] = $this->cObj->getSubpart($this->template['template'],'###LIST_ITEM###');
					$content.=$this->getList($where);
				break;
				case 'SINGLE':
					$this->template['template'] = $this->cObj->getSubpart($this->templateCode,'###TEMPLATE_SINGLE###');
					$content.=$this->getSingle($this->pid);
				break;
				case 'SINGLE_ID':
					$this->template['template'] = $this->cObj->getSubpart($this->templateCode,'###TEMPLATE_SINGLE_ID###');
					$this->template['listItem'] = $this->cObj->getSubpart($this->template['template'],'###LIST_SINGLE_ITEM###');
					$where[]='tx_sbdownloader_images.uid IN ('.$GLOBALS['TYPO3_DB']->cleanIntList($singlePIDs).')';
					$this->conf['view'] = 'SINGLE_ID';
					$content.=$this->getList($where);
					
				break;
				case 'SEARCH':
					$this->template['template'] = $this->cObj->getSubpart($this->templateCode,'###TEMPLATE_SEARCH###');
					$content.= $this->getSearch($this->keyword);
				break;
			}
		}

	  return $content;
	} // function main

	function getMarkerArray($image_row,$cat_rows=array()){
		// if preview image
		if(!empty($image_row['imagepreview'])) {
			$preview = $image_row['imagepreview'];
			$filepath = $this->filebasepath.$preview;
			$imageext = $this->checkMimeType($filepath);
			$img = $this->conf["image."];
			$img["file"] = $filepath;
			$showImage = $this->cObj->IMAGE($img);
		}else{
			// Check images, the first image or pdf file will be displayed as thumbnail
			$images = explode(',',$image_row['image']);
			foreach ($images as $val) {
				$filepath = $this->filebasepath.$val;
				$imageext = $this->checkMimeType($filepath);
				// allowed mime types
				$imagemimetypes = array(
					'image/gif',
					'image/jpeg',
					'image/png',
					'image/bmp',
					'image/tiff',
				);
				// if no preview image
				if(in_array($imageext,$imagemimetypes)) {
					$img = $this->conf["image."];
					$img["file"] = $filepath;
					$showImage = $this->cObj->IMAGE($img);
					break;
				}else{
					// check fileext
					$fileinfo = t3lib_div::split_fileref($val);
					$fileExt=trim($fileinfo['fileext']);
					if($fileExt == "pdf") {
						$img = $this->conf["image."];
						$img["file"] = $filepath;
						$showImage = $this->cObj->IMAGE($img);
						break;
					}else{
						$showImage = '';
					}
				}
			} // foreach ($images as $val)
		} // if(!empty($image_row['imagepreview')) {
		if(empty($image_row['clicks'])) {
			$image_row['clicks'] = '0';
		}
		$markerArray['###IMAGE###'] = $showImage;

		// If no ID is set in TS it will chose the site itself
		$id = $this->conf["singlePID"] ? $this->conf["singlePID"] : $GLOBALS["TSFE"]->id;
		// singleID of
		$singleID = $image_row['uid'];
		$more = $this->pi_linkToPage($this->pi_getLL('more'),$id,'',array('tx_sbdownloader_pi1[uid]' => $singleID));
		if($this->config['showMore']){
			$markerArray['###MORE###'] = $more;
		}elseif(!$showMore && !empty($image_row['longdescription'])) {
			$markerArray['###MORE###'] = $more;
		}else{
			$markerArray['###MORE###'] = '';
		}
		
		// overviewPID of the site
		// If no ID is set in TS it will chose the site itself
		if($this->conf["overviewPID"] == '') $this->conf["overviewPID"] = $GLOBALS["TSFE"]->id;
		$markerArray['###BACK###'] = $this->pi_linkToPage($this->pi_getLL('back'), $this->conf["overviewPID"]);

		$markerArray['###LINKS###'] = $this->generateDownloadLinks($image_row);

		$markerArray['###TITLE###'] = $image_row['name'];
		$categories=array();
		foreach(explode(',',$image_row['cat']) as $cat_id){
			$categories[]=$cat_rows[$cat_id]['cat'];
		}
		$markerArray['###CATEGORY###'] = $categories ? $this->pi_getLL('catDescription').implode(', ',$categories) : '';
		if($this->config['downloadcount']){
			$markerArray['###CLICKS###'] = $image_row['clicks'].' '.$this->pi_getLL('downloads');
		}else{
			$markerArray['###CLICKS###'] = '';
		}

		// Display Creationdate and -time !?    (KK)
		// displayCreationDate (0 = no date & time, 1 = only date, 2 = date & time)
//							$showCRDate = 2;
		if($this->config['showCRDate'] == "1") {
			$markerArray['###DATE###'] = $this->pi_getLL('since') . '&nbsp;' . date($this->conf['dateformat'], $image_row['crdate']);
		}elseif($showCRDate == "2"){
			$markerArray['###DATE###'] = $this->pi_getLL('since') . '&nbsp;' . date($this->conf['dateformat'], $image_row['crdate']) . '&nbsp;' . date($this->conf['timeformat'], $image_row['crdate']) . '&nbsp;' . $this->pi_getLL('oclock');
		}	else{
			$markerArray['###DATE###'] = '';
		}
		if($this->config['showEditDate']) {
			$markerArray['###LASTEDIT###'] = $this->pi_getLL('lastedit') . '&nbsp;' . date($this->conf['dateformat'], $image_row['tstamp']);
		}else{
			$markerArray['###LASTEDIT###'] = '';
		}
		if(!empty($image_row['description'])){
			$markerArray['###SHORTDESCRIPTION###'] = nl2br($this->getTypoLink($image_row['description']));
		}else{
			$markerArray['###SHORTDESCRIPTION###'] = '';
		}

		if(!empty($image_row['longdescription'])){
			$markerArray['###DESCRIPTION###'] = nl2br($this->getTypoLink($image_row['longdescription']));
		}else{
			$markerArray['###DESCRIPTION###'] = '';
		}

		return $markerArray;
	}

	function getList($where=array()){
		if($this->config['cat']) $where[]='uid_foreign='.$this->config['cat'];

		// Fetch downloads (mm)
		// print_r($this->getWhere('tx_sbdownloader_images'));
		// print_r($this->config);
		$res=$GLOBALS['TYPO3_DB']->exec_SELECT_mm_query('DISTINCT tx_sbdownloader_images.*','tx_sbdownloader_images','tx_sbdownloader_images_cat_mm','',($where ? ' AND '.implode(' AND ',$where) : '').$this->getWhere('tx_sbdownloader_images'),'',$this->config['orderby'].' '.$this->config['ascdesc']);
		
		while($image_row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){			
			$image_row=$this->getOverlay('tx_sbdownloader_images',$image_row);
			// print_r($image_row);
			if($image_row){
				$image_row=$this->getCategories($image_row);
				$markerArray=$this->getMarkerArray($image_row,$this->cat_rows);
				foreach($this->mHooks as $lHookObj) {
					if (method_exists($lHookObj, 'additionalListItemMarker')) {
						$markerArray = $lHookObj->additionalListItemMarker($markerArray,$image_row,$this);
					}
				}
				$content_item .= $this->cObj->substituteMarkerArrayCached($this->template['listItem'], $markerArray);
			}
		}

		$subpartArray['###CONTENT###'] = $content_item;
		return $this->cObj->substituteMarkerArrayCached($this->template['template'], $markerArray, $subpartArray);
	}

	/**
	 * Generates the search form
	 *
	 * @param	string	$keyword: search word
	 * @return	The generated form
	 */	
	function getSearch($keyword){
		$markerArray['###HEADLINE###'] = $this->pi_getLL('searchHeadline');
		$markerArray['###SUBMIT###'] = $this->pi_getLL('submit');
		$markerArray['###KEYWORD###'] = $keyword;
		$markerArray['###SEARCHPID###'] = $this->pi_getPageLink($GLOBALS["TSFE"]->id);
		$content = $this->cObj->substituteMarkerArrayCached($this->template['template'], array(), $markerArray);
		return $content;
	}

	/**
	 * Display only single items
	 *
	 * @param	int	$id: id of download
	 * @return	The generated item
	 */	
	function getSingle($id){
		// Fetch download
		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbdownloader_images','uid='.intval($id).$this->getWhere('tx_sbdownloader_images')); 
		if($image_row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
			$image_row=$this->getOverlay('tx_sbdownloader_images',$image_row);

			if($image_row){
				$image_row=$this->getCategories($image_row);
				$markerArray=$this->getMarkerArray($image_row,$this->cat_rows);
				foreach($this->mHooks as $lHookObj) {
					if (method_exists($lHookObj, 'additionalItemMarker')) {
						$markerArray = $lHookObj->additionalItemMarker($markerArray, $this);
					}
				}
				return $this->cObj->substituteMarkerArrayCached($this->template['template'], array(), $markerArray);
			}
		}
	}

	function getCategories($image_row){
		$cat_ids=array();
		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('uid_foreign','tx_sbdownloader_images_cat_mm','uid_local='.$image_row['uid'],'','sorting');
		while($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
			$cat_ids[]=$row['uid_foreign'];
			// Fetch categories
			if(!$this->cat_rows[$row['uid_foreign']]){
				$res2=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbdownloader_cat','uid='.$row['uid_foreign'].$this->getWhere('tx_sbdownloader_cat'));
				if($cat_row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res2)){
					$cat_row=$this->getOverlay('tx_sbdownloader_cat',$cat_row);
					if($cat_row){
						$this->cat_rows[$row['uid_foreign']]=$cat_row;
					}
				}
			}
		}
		$image_row['cat']=implode(',',$cat_ids);
		return $image_row;
	}

	function getWhere($table){
		// Enable fields
		$where=$this->cObj->enableFields($table);	
		// Translation if no single_id
		if($this->conf['view'] == 'SINGLE_ID'){
			return false;
		}else{
		$ctrl=$GLOBALS['TCA'][$table]['ctrl'];

			$where.=' AND ('.$table.'.'.$ctrl['languageField'].' IN (-1,0)';
			if($GLOBALS['TSFE']->sys_language_content && $ctrl['transOrigPointerField']){
				$where.=' OR ('.$table.'.'.$ctrl['languageField'].'='.intval($GLOBALS['TSFE']->sys_language_content).' AND '.$table.'.'.$ctrl['transOrigPointerField'].'=0)';
			}
			$where.=')';
		
		// Version
		$where.=' AND '.$table.'.pid>=0';	
		return $where;
		}
	}
	
	/**
	 * Get language overlay
	 *
	 * @param	int		$table: database table
	 * @param	array	$row: query of original records
	 * @return	The overlay language
	 */
	function getOverlay($table,$row){		
		// Translation
		// - Table has translation
		// - Current language is not default
		// - Translation is enabled
		if (is_array($row) && $row['sys_language_uid'] != $GLOBALS['TSFE']->sys_language_content && $this->lang) {
			$row=$GLOBALS['TSFE']->sys_page->getRecordOverlay($table,$row,$GLOBALS['TSFE']->sys_language_content,$GLOBALS['TSFE']->sys_language_contentOL);
		}
		
		// print_r($row);
		// Version
		// - Table has versioning
		// - Current user is in workspace
		// - Versioning is enabled
		if($GLOBALS['TCA'][$table]['ctrl']['versioningWS'] && $GLOBALS['BE_USER']->workspace && t3lib_extMgm::isLoaded('version')){
			$GLOBALS['TSFE']->sys_page->versionOL($table,$row);
		}
		return $row;
	}
	
	/**
	 * Generates the download links
	 *
	 * @param	int		$uid: The download uid
	 * @param	array		$downloaddescription:1 = filename.fileextension, 2 = filename, 3 = fileextension
	 * @param	array		$downloadIcon: which downloadicon
	 * @param	array		$filesize: show filesize (true/false)
	 * @param array		$mode: values (all=all information, icon=only icons, size=only filesize, links=only links)
	 * @return	The generated links
	 */
	function generateDownloadLinks($row){
		// Template settings
		$templateflex_file = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_file', 's_template');
		$this->templateCode = $this->cObj->fileResource($templateflex_file?'uploads/tx_sbdownloader/' .	 $templateflex_file:$this->conf['templateFile']);
		$template['templateLinks'] = $this->cObj->getSubpart($this->templateCode,'###TEMPLATE_LINKS###');
		$template['linkItem'] = $this->cObj->getSubpart($template['templateLinks'],'###LINK_ITEM###');

		// explode link description
		$description = explode('<br />',nl2br($row['downloaddescription']));
		$linkdescription = explode('<br />',nl2br($row['linkdescription']));
		$i = 0;

		if(!empty($row['image'])){
			// explode images
			$images = explode(',',$row['image']);
			foreach ($images as $val) {
				// break loop if only first record should be displayed
				if($this->config['onlyFirst'] && $i == 1) break;
				$markerArray=$this->generateDownloadLink($row['uid'],$val,$description[$i],$linkdescription[$i]);
				$link_item .= $this->cObj->substituteMarkerArrayCached($template['linkItem'], $markerArray);
				$i++;
			} //foreach ($images as $val) {
		}

		if(!empty($row['externallinks'])){
			// External links
			$external = explode(',',$row['externallinks']);
			foreach ($external as $key=>$val) {
				if($this->config['onlyFirst'] && $i == 1) break;
				$markerArray=$this->generateDownloadLink($row['uid'],$val,$description[$i],$linkdescription[$i],$key+1);
				$link_item .= $this->cObj->substituteMarkerArrayCached($template['linkItem'], $markerArray);
				$i++;
			}
		}

		$subpartArray['###CONTENT_LINK###'] = $link_item;
		$content .= $this->cObj->substituteMarkerArrayCached($template['templateLinks'], $markerArray, $subpartArray);

		return $content;
	}

	function generateDownloadLink($uid,$val,$description,$linkdescription,$external=false){
		$markerArray['###ICON###'] = '';
		$markerArray['###LINK###'] = '';
		$markerArray['###FILESIZE###'] = '';
		$markerArray['###MODIFICATIONDATE###'] = '';
		$markerArray['###LINKDESCRIPTION###'] = '';
		$fileinfo = t3lib_div::split_fileref($val);

		// read out link descriptions
		if(!empty($row['linkdescription'])){
			$markerArray['###LINKDESCRIPTION###'] = trim($this->getTypoLink($linkdescription));
		}

		// no description given
		if($this->conf['forcelinkdescription']){
			// check typoscript settings
			switch($this->conf["linkdescription"]){
				case 1:
					$fileName=trim($fileinfo['filebody']).'.'.trim($fileinfo['fileext']);
					break;
				case 2:
					$fileName=trim($fileinfo['filebody']);
					break;
				case 3:
					$fileName=trim($fileinfo['fileext']);
					break;
			}
		// description given
		}else{
			$fileName=trim($description);
		}

		// Render Downloadicon        (KK)
		$strDLI = '';
		if(!empty($this->conf["downloadIcon"])){
			// Link params
			$params = array(
				'title' => $this->pi_getLL('linkTitle'),
				'rel' => 'nofollow'
			);
			// print_r($this->conf['linkTarget']);
			if ($this->conf['linkTarget'] != '') {
				$params['target'] = $this->conf['linkTarget'];
			}

			if (substr($this->conf["downloadIcon"],-1)=='/') {     	// so the last letter is a Slash!
				// now we take the corresponding GIFs for the different file-extensions,
				// normally in folder "typo3/gfx/fileicons/"
				// if file icon exist
				if(file_exists($this->conf["downloadIcon"].trim($fileinfo['fileext'].'.gif'))){					
					$strDLI = '<img src="'.$this->conf["downloadIcon"].trim($fileinfo['fileext']).'.gif" width="18" height="16">';
				}else{
					$strDLI = '<img src="'.$this->conf["missingDownloadIcon"].'">';
				}
			} else {
				$strDLI = '<img src="'.$this->conf["downloadIcon"].'">';
			}
			//secureDownloads						
			if($this->config['secureDownloads']){
				$icon = $this->pi_linkTP($strDLI, $urlParameters=array('download' => $val, 'did' => $uid));
				$markerArray['###ICON###'] = $this->cObj->addParams($icon,$params);
			}else{
				$file=$this->filebasepath.$val;				
				$markerArray['###ICON###'] = $this->pi_linkToPage($strDLI,$file,$this->conf['linkTarget']);
			}
		}else{
			$markerArray['###ICON###'] = '';
		}
		// if empty filename
		if(empty($fileName)){
			$fileName = $val;
		}

		// build link via typolink
		$temp_conf = $this->typolink_conf;
		$temp_conf["section"] .= '';
		$temp_conf['target']=$this->conf['linkTarget'];
		//secureDownloads
		if($this->config['secureDownloads']){
			$temp_conf["additionalParams"] .= '&no_cache=1&download='.($external ? $external : $val).'&did='.$uid;
			$temp_conf["addQueryString"] = true;                                          
			$temp_conf["useCacheHash"] = false;
		}else{
			unset($temp_conf['parameter.']);
			$temp_conf['parameter']=($external ? '' : $this->filebasepath).$val;
		}
		$link = $this->local_cObj->typolink($fileName, $temp_conf);
		$markerArray['###LINK###'] = $this->cObj->addParams($link,$params);

		// filesize
		if($this->config['filesize'] && !$external){
			$downloadfile = $this->filebasepath.$val;
			$valfilesize = filesize($downloadfile);
			$valfilesize = $this->format_size($valfilesize);
			$markerArray['###FILESIZE###'] = ' '.$this->pi_getLL('bracketstart').$this->pi_getLL('filesize').$valfilesize.$this->pi_getLL('bracketend');
		}
		// file modification date
		if($this->config['showFiledate'] && !$external){
			$downloadfile = $this->filebasepath.$val;
			$filemtime = filemtime($downloadfile);
			$dateTimeFormat = $this->conf['datetimeformat'];
			if ($dateTimeFormat == '' || empty($dateTimeFormat)) $dateTimeFormat = "d.m.Y H:i";
			$strFilemtime = date($dateTimeFormat, $filemtime);
			$mdsc = trim($this->conf['fileMDateClass']);
			$markerArray['###MODIFICATIONDATE###'] = $this->pi_getLL('fileDate').$strFilemtime;
		}

		return $markerArray;
	}

	/**
	 * Format filesize
	 *
	 * @param	int		$size: size of file in bytes
	 * @param	array		$round filesize: true/false
	 * @return	return formated filesize
	 */
	function format_size($size, $round = 0) {
    //Size must be bytes!
    $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
    for ($i=0; $size > 1024 && $i < count($sizes) - 1; $i++) $size /= 1024;
    return round($size,$round).$sizes[$i];
}

	/**
	 * checks mime_type of an image
	 *
	 * @param	int		$file: filename
	 * @return	mimetype
	 */
	function checkMimeType($file){
			$imageinfos=getimagesize($file);			 // read image info
			$imagetype=$imageinfos[2];                     // image-type
			$mimetype=image_type_to_mime_type($imagetype); // mime-type
			return $mimetype;
	}

	/**
	 * Download the file
	 *
	 * @param	string		$image: Name of download
	 * @param	array		$uid: download uid for click counter
	 */
	function downloadImage($image,$uid){
		// update counter
		$GLOBALS['TYPO3_DB']->exec_UPDATEquery(
			'tx_sbdownloader_images',
			'uid='.$uid,
			array(
				'clicks' => 'clicks+1',
			),
			array('clicks')
		);		
		
		if(is_numeric($image)){
			$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('externallinks','tx_sbdownloader_images','uid='.intval($uid));
			if($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
				$external = empty($row['externallinks']) ? array() : explode(',',$row['externallinks']);
				if($external[$image-1]){
					header('Location: '.t3lib_div::locationHeaderUrl($external[$image-1]));
					header('X-Note: Redirect by sb_downloader');
					header('Connection: close');
				}
			}
		}else{
			$downloadfile = $this->filebasepath.$image;
			$filesize = filesize($downloadfile);
			$filename = $image;

			// check Mimetype
			$mimetype = $this->checkMimeType($downloadfile);

			header("Content-Type: $mimetype");
			header("Content-Disposition: attachment; filename=$filename");
			header("Content-Length: $filesize");
			ob_end_clean();
			readfile($downloadfile);

			ob_start();
			// Here a hook for additional Smarty Vars
			// Methode to implement in hook object
			// $lHook->downloadCompleted($uid, tx_sbdownloader_pi1 &$pPiRef);
			foreach($this->mHooks as $lHookObj) {
				if (method_exists($lHookObj, 'downloadCompleted')) {
					$lHookObj->downloadCompleted($uid, $this);
				}
			}
			ob_end_clean();
//    ob_end_flush();
			exit;
		}
	} // function downloadImage

	protected function initHooks(){
		// First user defined objects (if any) for hooks which extend some functionality:
		$this->mHooks = array();
		//t3lib_div::debug($GLOBALS ['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey]);
		if (is_array ($GLOBALS ['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey])) {
			foreach ($GLOBALS ['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey] as $classRef) {
				$this->mHooks[] = &t3lib_div::getUserObj($classRef);			
			}
		}
	}// function initHooks

	/**
	 * Generate links from typolink syntax
	 *
	 * @param	string		$str: string to be parsed
	 */

  function getTypoLink($str){
    // no p-tags in link
    $parseFunc = $GLOBALS['TSFE']->tmpl->setup['lib.']['parseFunc_RTE.'];
    $parseFunc['nonTypoTagStdWrap.']['encapsLines.']['removeWrapping'] = 1;
    // remove &nbsp;
    $parseFunc['nonTypoTagStdWrap.']['encapsLines.']['innerStdWrap_all.']['ifBlank'] = '';
    $out = $this->cObj->parseFunc($str, $parseFunc);  
    return $out;    
  }

} // class end


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sb_downloader/pi1/class.tx_sbdownloader_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sb_downloader/pi1/class.tx_sbdownloader_pi1.php']);
}

?>
